Index: main/plugin-web/resources/js/org/ametys/web/page/TemplatesMenu.i18n.js
===================================================================
--- main/plugin-web/resources/js/org/ametys/web/page/TemplatesMenu.i18n.js	(revision 26836)
+++ main/plugin-web/resources/js/org/ametys/web/page/TemplatesMenu.i18n.js	(working copy)
@@ -301,11 +301,18 @@
     {
 	   return;
     }
+    
+    var zoneName = response.selectSingleNode("ActionResult/zonename")[org.ametys.servercomm.ServerComm.xmlTextContent];
 
 	var pageTargets = [];
 	for (var i = 0; i &lt; args.length; i++)
 	{
-		pageTargets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget("page", {'id': args[i]}));
+		var param = {'id': args[i]};
+		if (zoneName)
+		{
+			param["zone-name"] = zoneName;
+		}
+		pageTargets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget("page", param));
 	}
 	
 	var message1 = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage("typeChanged", null, pageTargets);
Index: main/plugin-web/sitemap-front.xmap
===================================================================
--- main/plugin-web/sitemap-front.xmap	(revision 26836)
+++ main/plugin-web/sitemap-front.xmap	(working copy)
@@ -58,6 +58,7 @@
 		
 		<map:serializers>
             <map:serializer name="fo2pdf" mime-type="application/pdf" src="org.ametys.runtime.cocoon.FOPNGSerializer" />
+			<map:serializer name="html-doc" mime-type="application/vnd.ms-word" src="org.apache.cocoon.serialization.HTMLSerializer" />
 		</map:serializers>
 		
 		<map:actions>
@@ -572,6 +573,26 @@
                 </map:act>
             </map:match>
             
+            <map:match pattern="content-type.*.doc">
+                <map:act type="get-ctype-infos">
+                    <map:aggregate element="view">
+                        <map:part src="cocoon:/content"/>
+                        <map:part src="cocoon:/content-pages"/>
+                    </map:aggregate>
+                    <map:transform type="i18n">
+                        <map:parameter name="locale" value="{request-attr:renderingLanguage}"/>
+                        <map:parameter name="plugin" value="{request-attr:pluginName}"/>
+                    </map:transform>
+                    <map:transform src="content-view://{../1}/view-{request-param:metadataSetName}/doc.xsl"/>
+                    <map:transform type="docbook-enhancement"/>
+                    <map:transform type="i18n">
+                        <map:parameter name="locale" value="{request-attr:renderingLanguage}"/>
+                        <map:parameter name="plugin" value="{pluginName}"/>
+                    </map:transform>
+                    <map:serialize type="html-doc"/>
+                </map:act>
+            </map:match>
+            
             <map:match pattern="content-type.*.html">
                 <map:act type="get-ctype-infos">
                     <map:aggregate element="view">
Index: main/plugin-web/src/org/ametys/web/clientsideelement/TemplatesMenu.java
===================================================================
--- main/plugin-web/src/org/ametys/web/clientsideelement/TemplatesMenu.java	(revision 26836)
+++ main/plugin-web/src/org/ametys/web/clientsideelement/TemplatesMenu.java	(working copy)
@@ -27,6 +27,7 @@
 import org.ametys.plugins.repository.AmetysObjectResolver;
 import org.ametys.runtime.ui.impl.StaticContextualClientSideElement;
 import org.ametys.runtime.util.I18nizableText;
+import org.ametys.runtime.util.JSONUtils;
 import org.ametys.web.repository.page.Page;
 import org.ametys.web.repository.site.Site;
 import org.ametys.web.repository.site.SiteManager;
@@ -65,7 +66,7 @@
     {
         Map<String, I18nizableText> parameters = new HashMap<String, I18nizableText>();
         parameters.putAll(_initialParameters);
-        
+
         String siteName = (String) contextualParameters.get("site");
         
         _configureTemplates(parameters, siteName);
Index: main/plugin-web/src/org/ametys/web/clientsideelement/AddPageClientSideElement.java
===================================================================
--- main/plugin-web/src/org/ametys/web/clientsideelement/AddPageClientSideElement.java	(revision 0)
+++ main/plugin-web/src/org/ametys/web/clientsideelement/AddPageClientSideElement.java	(revision 0)
@@ -0,0 +1,201 @@
+/*
+ *  Copyright 2014 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.web.clientsideelement;
+
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Set;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.commons.lang.StringUtils;
+
+import org.ametys.cms.contenttype.ContentType;
+import org.ametys.cms.contenttype.ContentTypeExtensionPoint;
+import org.ametys.plugins.repository.AmetysObjectResolver;
+import org.ametys.runtime.right.RightsManager.RightResult;
+import org.ametys.runtime.ui.impl.StaticContextualClientSideElement;
+import org.ametys.runtime.util.I18nizableText;
+import org.ametys.web.repository.page.Page;
+import org.ametys.web.repository.site.Site;
+import org.ametys.web.repository.site.SiteManager;
+import org.ametys.web.service.Service;
+import org.ametys.web.service.ServiceExtensionPoint;
+import org.ametys.web.skin.Skin;
+import org.ametys.web.skin.SkinTemplate;
+import org.ametys.web.skin.SkinsManager;
+
+
+/**
+ * Get all templates, contents, services
+ *
+ */
+public class AddPageClientSideElement extends StaticContextualClientSideElement
+{    
+    /** The content type extension point. */
+    protected ContentTypeExtensionPoint _contentTypeExtensionPoint;
+    /** The service extension point. */
+    protected ServiceExtensionPoint _serviceExtensionPoint;
+    /** The skins manager */
+    protected SkinsManager _skinsManager;
+    /** The site manager */
+    protected SiteManager _siteManager;
+    /** The Ametys resolver */
+    protected AmetysObjectResolver _resolver;
+    
+    @Override
+    public void service(ServiceManager smanager) throws ServiceException
+    {
+        super.service(smanager);
+        _contentTypeExtensionPoint = (ContentTypeExtensionPoint) smanager.lookup(ContentTypeExtensionPoint.ROLE);
+        _serviceExtensionPoint = (ServiceExtensionPoint) smanager.lookup(ServiceExtensionPoint.ROLE);
+        _skinsManager = (SkinsManager) smanager.lookup(SkinsManager.ROLE);
+        _siteManager = (SiteManager) smanager.lookup(SiteManager.ROLE);
+        _resolver = (AmetysObjectResolver) smanager.lookup(AmetysObjectResolver.ROLE);
+    }
+    
+    @Override
+    public Map<String, I18nizableText> getParameters(Map<String, Object> contextualParameters)
+    {
+        Map<String, I18nizableText> parameters = new HashMap<String, I18nizableText>();
+        parameters.putAll(_initialParameters);
+        parameters.putAll(_getTemplatesParameter(contextualParameters));
+        parameters.putAll(_getContentsParameter());
+        parameters.putAll(_getServicesParameter());
+
+        return parameters;
+
+    }
+    
+    // get all templates
+    private Map<String, I18nizableText> _getTemplatesParameter(Map<String, Object> contextualParameters)
+    {
+        Map<String, I18nizableText> parameters = new HashMap<String, I18nizableText>();
+        
+        String siteName = (String) contextualParameters.get("site");
+        Site site = _siteManager.getSite(siteName);
+        String skinId = site.getSkinId();
+        Skin skin = _skinsManager.getSkin(skinId);
+        Set<String> templatesId = skin.getTemplates();
+        
+        parameters.put("templates-size", new I18nizableText(Integer.toString(templatesId.size())));
+        
+        int i = 0;
+        for (String templateId : templatesId)
+        {
+            SkinTemplate template = skin.getTemplate(templateId);
+            
+            parameters.put("template-" + i + "-id", new I18nizableText(templateId));
+            parameters.put("template-" + i + "-label", template.getLabel());
+            parameters.put("template-" + i + "-description", template.getDescription());
+         //   parameters.put("template-" + i + "-iconSmall", new I18nizableText(template.getSmallImage()));
+            parameters.put("template-" + i + "-iconMedium", new I18nizableText(template.getMediumImage()));
+         //   parameters.put("template-" + i + "-iconLarge", new I18nizableText(template.getLargeImage()));
+
+            i++;
+        }
+        
+        return parameters;
+    }
+    
+    // get all contents
+    private Map<String, I18nizableText> _getContentsParameter()
+    {
+        Map<String, I18nizableText> parameters = new HashMap<String, I18nizableText>();
+            
+        Set<String> contentTypesIds = _contentTypeExtensionPoint.getExtensionsIds();
+        
+        int i = 0;
+        for (String contentTypeId : contentTypesIds)
+        {
+            ContentType contentType = _contentTypeExtensionPoint.getExtension(contentTypeId);
+            
+         //   parameters.put("content-" + i + "-group", contentType.getLabel());
+            parameters.put("content-" + i + "-id", new I18nizableText(contentTypeId));
+          //  parameters.put("content-" + i + "-action", this._initialParameters.get("content-actions"));
+            parameters.put("content-" + i + "-label", contentType.getLabel());
+            parameters.put("content-" + i + "-defaultTitle", contentType.getDefaultTitle());
+            parameters.put("content-" + i + "-description", contentType.getDescription());
+         //   parameters.put("content-" + i + "-iconSmall", new I18nizableText(contentType.getSmallIcon()));
+            parameters.put("content-" + i + "-iconMedium", new I18nizableText(contentType.getMediumIcon()));
+            
+            i++;
+        }
+        
+        parameters.put("contents-size", new I18nizableText(Integer.toString(i)));
+        
+        return parameters;    
+    }
+    
+    // get all services
+    private Map<String, I18nizableText> _getServicesParameter()
+    {
+        Map<String, I18nizableText> parameters = new HashMap<String, I18nizableText>();
+            
+        Set<String> serviceIds = _serviceExtensionPoint.getExtensionsIds();
+        
+        int i = 0;
+        for (String serviceId : serviceIds)
+        {
+            Service service = _serviceExtensionPoint.getExtension(serviceId);
+            
+         //   parameters.put("service-" + i + "-group", service.getLabel());
+            parameters.put("service-" + i + "-id", new I18nizableText(serviceId));
+            parameters.put("service-" + i + "-parameters-action", new I18nizableText(service.getParametersScript().getScriptClassname()));
+          //  parameters.put("service-" + i + "-action", this._initialParameters.get("service-actions"));
+            parameters.put("service-" + i + "-label", service.getLabel());
+            parameters.put("service-" + i + "-description", service.getDescription());
+         //   parameters.put("service-" + i + "-iconSmall", new I18nizableText(service.getSmallIcon()));
+            parameters.put("service-" + i + "-iconMedium", new I18nizableText(service.getMediumIcon()));
+            
+            i++;
+        }
+        
+        parameters.put("services-size", new I18nizableText(Integer.toString(i)));
+        
+        return parameters;    
+    }
+    
+    @Override
+    public Map<String, I18nizableText> getCurrentParameters(Map<String, Object> parameters)
+    {
+        String pageId = (String) parameters.get("pageId");
+        Page page = _resolver.resolveById(pageId);
+        
+        Map<String, I18nizableText> result = new HashMap<String, I18nizableText>();
+        
+        for (String key : _initialParameters.keySet())
+        {
+            if (key.startsWith("right-"))
+            {
+                String right = _initialParameters.get(key).getLabel();
+                
+                boolean hasRight = true;
+                if (StringUtils.isNotBlank(right))
+                {
+                    String context = "/pages/" + page.getSitemapName() + "/" + page.getPathInSitemap();
+                    hasRight = _rightsManager.hasRight(_currentUserProvider.getUser(), right, context) == RightResult.RIGHT_OK;
+                }
+                
+                result.put(key, new I18nizableText(hasRight ? "true" : "false"));
+            }
+        }
+        
+        return result;
+    }
+    
+    
+}
Index: main/plugin-web/src/org/ametys/web/skin/SkinTemplate.java
===================================================================
--- main/plugin-web/src/org/ametys/web/skin/SkinTemplate.java	(revision 26836)
+++ main/plugin-web/src/org/ametys/web/skin/SkinTemplate.java	(working copy)
@@ -21,6 +21,7 @@
 import java.io.InputStream;
 import java.util.Date;
 import java.util.HashMap;
+import java.util.LinkedHashMap;
 import java.util.Map;
 
 import org.apache.avalon.framework.configuration.Configuration;
@@ -85,7 +86,7 @@
         this._smallImage = "/plugins/web/resources/img/skin/template_16.png";
         this._mediumImage = "/plugins/web/resources/img/skin/template_32.png";
         this._largeImage = "/plugins/web/resources/img/skin/template_48.png";
-        this._zones = new HashMap<String, SkinTemplateZone>();
+        this._zones = new LinkedHashMap<String, SkinTemplateZone>();
     }
     
     /**
@@ -115,11 +116,11 @@
                     this._mediumImage = _configureThumbnail(configuration.getChild("thumbnail").getChild("medium").getValue(null), this._mediumImage);
                     this._largeImage = _configureThumbnail(configuration.getChild("thumbnail").getChild("marge").getValue(null), this._largeImage);
                     
-                    this._zones = new HashMap<String, SkinTemplateZone>();
+                    this._zones = new LinkedHashMap<String, SkinTemplateZone>();
                     for (Configuration zoneConfiguration : configuration.getChild("zones").getChildren("zone"))
                     {
                         String zoneId = zoneConfiguration.getAttribute("id");
-                        String zoneType = zoneConfiguration.getAttribute("type", "primary");
+                        String zoneType = zoneConfiguration.getAttribute("type", SkinTemplateZone.TYPE_PRIMARY);
                         I18nizableText label = _configureI18n(zoneConfiguration.getChild("label", false), new I18nizableText(zoneId));
                         I18nizableText description = _configureI18n(zoneConfiguration.getChild("description", false), new I18nizableText(zoneId));
                         String smallImage = _configureThumbnail(zoneConfiguration.getChild("thumbnail").getChild("small").getValue(null), "/plugins/web/resources/img/skin/zone_16.png");
Index: main/plugin-web/src/org/ametys/web/skin/ApplyTemplatesAction.java
===================================================================
--- main/plugin-web/src/org/ametys/web/skin/ApplyTemplatesAction.java	(revision 26836)
+++ main/plugin-web/src/org/ametys/web/skin/ApplyTemplatesAction.java	(working copy)
@@ -15,6 +15,7 @@
  */
 package org.ametys.web.skin;
 
+import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
@@ -53,12 +54,35 @@
         
         List<String> pagesIds = (List<String>) jsParameters.get("pages");
         String template = (String) jsParameters.get("template");
+
+        String defaultZoneName = null;
         
         for (String pageId : pagesIds)
         {
             // FIXME API test if not modifiable
             ModifiablePage page = _resolver.resolveById(pageId);
             
+            if (defaultZoneName == null)
+            {
+                String skinId = page.getSite().getSkinId();
+                SkinTemplate tpl = _skinsManager.getSkin(skinId).getTemplate(template);
+                if (tpl == null)
+                {
+                    throw new IllegalStateException("Template '" + template + "' does not exists on skin '" + skinId + "'");
+                }
+                
+                Map<String, SkinTemplateZone> zones = tpl.getZones();
+                for (String zoneId : zones.keySet())
+                {
+                    SkinTemplateZone zone = zones.get(zoneId);
+                    if (SkinTemplateZone.TYPE_PRIMARY.equals(zone.getType())
+                        && ("default".equals(zone.getId()) || defaultZoneName == null))
+                    {
+                        defaultZoneName = zone.getId();
+                    }
+                }
+            }
+            
             if (page.getType().equals(PageType.CONTAINER))
             {
                 _removeOldZones (page, template);
@@ -70,7 +94,12 @@
             _observationManager.notify(new Event(_getCurrentUser(), ObservationConstants.PAGE_CHANGED, page));
         }
         
-        return EMPTY_MAP;
+        Map<String, String> results = new HashMap<String, String>();
+        if (defaultZoneName != null)
+        {
+            results.put("zonename", defaultZoneName);
+        }
+        return results;
     }
     
     private void _removeOldZones (ModifiablePage page, String templateName)
Index: main/plugin-web/src/org/ametys/web/skin/SkinTemplateZone.java
===================================================================
--- main/plugin-web/src/org/ametys/web/skin/SkinTemplateZone.java	(revision 26836)
+++ main/plugin-web/src/org/ametys/web/skin/SkinTemplateZone.java	(working copy)
@@ -29,6 +29,11 @@
  */
 public class SkinTemplateZone
 {
+    /** The type of a primary zone */
+    public static final String TYPE_PRIMARY = "primary";
+    /** The type of a secondary zone */
+    public static final String TYPE_SECONDARY = "secondary";
+    
     private static Logger _logger = LoggerFactory.getLoggerFor(SkinTemplateZone.class);
 
     /** The skin id */
@@ -209,6 +214,15 @@
     }
     
     /**
+     * Get the zone type (primary or secondary)
+     * @return the type
+     */
+    public String getType()
+    {
+        return _type;
+    }
+    
+    /**
      * Get the name of the zone to inherit in the given template
      * @param templateName The name of the template. Cannot be empty, null or a joker.
      * @return The name of a zone in that template, or null is not applicable for this template.
Index: main/plugin-web/src/org/ametys/web/repository/page/generators/AvailableContentsAndServicesGenerator.java
===================================================================
--- main/plugin-web/src/org/ametys/web/repository/page/generators/AvailableContentsAndServicesGenerator.java	(revision 0)
+++ main/plugin-web/src/org/ametys/web/repository/page/generators/AvailableContentsAndServicesGenerator.java	(revision 0)
@@ -0,0 +1,238 @@
+/*
+ *  Copyright 2014 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.web.repository.page.generators;
+
+import java.io.IOException;
+import java.util.Map;
+import java.util.Set;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.ProcessingException;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.generation.ServiceableGenerator;
+import org.apache.cocoon.xml.AttributesImpl;
+import org.apache.cocoon.xml.XMLUtils;
+import org.xml.sax.SAXException;
+
+import org.ametys.cms.contenttype.ContentType;
+import org.ametys.cms.contenttype.ContentTypeExtensionPoint;
+import org.ametys.plugins.repository.AmetysObjectResolver;
+import org.ametys.runtime.right.RightsManager;
+import org.ametys.runtime.right.RightsManager.RightResult;
+import org.ametys.runtime.user.CurrentUserProvider;
+import org.ametys.web.repository.page.ContentTypesAssignmentHandler;
+import org.ametys.web.repository.page.ModifiablePage;
+import org.ametys.web.repository.page.Page;
+import org.ametys.web.repository.page.Page.PageType;
+import org.ametys.web.repository.page.ServicesAssignmentHandler;
+import org.ametys.web.repository.site.SiteManager;
+import org.ametys.web.service.Service;
+import org.ametys.web.service.ServiceExtensionPoint;
+import org.ametys.web.skin.SkinTemplate;
+import org.ametys.web.skin.SkinTemplateZone;
+import org.ametys.web.skin.SkinsManager;
+
+/**
+ * SAX the available contents and services of a given page
+ *
+ */
+public class AvailableContentsAndServicesGenerator extends ServiceableGenerator
+{
+    /** The current user provider */
+    protected CurrentUserProvider _currentUserProvider;
+    
+    /** The rights manager */
+    protected RightsManager _rightsManager;
+    
+    /** The content types assignment handler */
+    protected ContentTypesAssignmentHandler _cTypeHandler;
+    
+    /** The service assignment handler */
+    protected ServicesAssignmentHandler _serviceHandler;
+    
+    /** Repository content */
+    protected AmetysObjectResolver _resolver;
+    
+    /** Manages the templates */
+    protected SkinsManager _skinsManager;
+    
+    /** The content type extension point. */
+    protected ContentTypeExtensionPoint _contentTypeExtensionPoint;
+   
+    /** The service extension point. */
+    protected ServiceExtensionPoint _serviceExtensionPoint;
+
+
+    @Override
+    public void service(ServiceManager smanager) throws ServiceException
+    {
+        super.service(smanager);
+        _resolver = (AmetysObjectResolver) smanager.lookup(AmetysObjectResolver.ROLE);
+        _skinsManager = (SkinsManager) smanager.lookup(SkinsManager.ROLE);
+        _cTypeHandler = (ContentTypesAssignmentHandler) smanager.lookup(ContentTypesAssignmentHandler.ROLE);
+        _serviceHandler = (ServicesAssignmentHandler) smanager.lookup(ServicesAssignmentHandler.ROLE);
+        _contentTypeExtensionPoint = (ContentTypeExtensionPoint) smanager.lookup(ContentTypeExtensionPoint.ROLE);
+        _serviceExtensionPoint = (ServiceExtensionPoint) smanager.lookup(ServiceExtensionPoint.ROLE);
+        _currentUserProvider = (CurrentUserProvider) smanager.lookup(CurrentUserProvider.ROLE);
+        _rightsManager = (RightsManager) smanager.lookup(RightsManager.ROLE);
+    } 
+    
+    public void generate() throws IOException, SAXException, ProcessingException
+    {
+        Map<String, Object> jsParameters = (Map<String, Object>) objectModel.get(ObjectModelHelper.PARENT_CONTEXT);
+
+        String pageId = (String) jsParameters.get("pageId");
+        String template = (String) jsParameters.get("template");
+        
+        ModifiablePage page = _resolver.resolveById(pageId);
+        
+        String skinId = page.getSite().getSkinId();
+        SkinTemplate tpl = _skinsManager.getSkin(skinId).getTemplate(template);
+        if (tpl == null)
+        {
+            throw new IllegalStateException("Template '" + template + "' does not exists on skin '" + skinId + "'");
+        }
+        
+        String defaultZoneName = null;
+        Map<String, SkinTemplateZone> zones = tpl.getZones();
+        for (String zoneId : zones.keySet())
+        {
+            SkinTemplateZone zone = zones.get(zoneId);
+            if (SkinTemplateZone.TYPE_PRIMARY.equals(zone.getType())
+                && ("default".equals(zone.getId()) || defaultZoneName == null))
+            {
+                defaultZoneName = zone.getId();
+            }
+        }
+        
+        // Set temporary the template to get availables contents and services
+        page.setType(PageType.CONTAINER);
+        page.setTemplate(template);
+        
+        contentHandler.startDocument();
+        XMLUtils.startElement(contentHandler, "items");
+        Set<String> contentTypesIds = _cTypeHandler.getAvailableContentTypes(page, defaultZoneName);
+        Set<String> servicesIds = _serviceHandler.getAvailableServices(page, defaultZoneName);
+        _saxContents(contentTypesIds, page);
+        _saxServices(servicesIds, page);
+        XMLUtils.endElement(contentHandler, "items");
+        contentHandler.endDocument();
+       
+        page.getSitemap().revertChanges();
+    }
+
+    
+    private void _saxContents(Set<String> contentTypesIds, Page page) throws SAXException
+    {
+        XMLUtils.startElement(contentHandler, "contents");
+        
+        for (String nameC : contentTypesIds)
+        {
+            if (hasRightContent(nameC, page))
+            {
+                AttributesImpl attrsC = new AttributesImpl();
+                attrsC.addCDATAAttribute("id", nameC);
+                XMLUtils.createElement(contentHandler, "content", attrsC);
+            }
+        }
+        
+        XMLUtils.endElement(contentHandler, "contents");
+    }
+    
+    private void _saxServices(Set<String> servicesIds, Page page) throws SAXException
+    {
+        XMLUtils.startElement(contentHandler, "services");
+        
+        for (String nameS : servicesIds)
+        {
+            if (hasRightService(nameS, page))
+            {
+                AttributesImpl attrsS = new AttributesImpl();
+                attrsS.addCDATAAttribute("id", nameS);
+                XMLUtils.createElement(contentHandler, "service", attrsS);
+            }
+           
+        }
+        
+        XMLUtils.endElement(contentHandler, "services");
+    }
+    
+    /**
+     * Test if the current user has the right needed by the content type to create a content.
+     * @param contentTypeId the content type ID.
+     * @param page the current page.
+     * @return true if the user has the right needed, false otherwise.
+     */
+    protected boolean hasRightContent(String contentTypeId, Page page)
+    {
+        boolean hasRight = false;
+        
+        ContentType contentType = _contentTypeExtensionPoint.getExtension(contentTypeId);
+        
+        if (contentType != null)
+        {
+            String right = contentType.getRight();
+            
+            if (right == null)
+            {
+                hasRight = true;
+            }
+            else
+            {
+                String login = _currentUserProvider.getUser();
+                String context = "/pages/" + page.getSitemapName() + "/" + page.getPathInSitemap();
+                
+                hasRight = _rightsManager.hasRight(login, right, context) == RightResult.RIGHT_OK;
+            }
+        }
+        
+        return hasRight;
+    }
+    
+    /**
+     * Test if the current user has the right needed by the service to create it.
+     * @param serviceId the service ID.
+     * @param page the current page.
+     * @return true if the user has the right needed, false otherwise.
+     */
+    protected boolean hasRightService(String serviceId, Page page)
+    {
+        boolean hasRight = false;
+        
+        Service service = _serviceExtensionPoint.getExtension(serviceId);
+        
+        if (service != null)
+        {
+            String right = service.getRight();
+            
+            if (right == null)
+            {
+                hasRight = true;
+            }
+            else
+            {
+                String login = _currentUserProvider.getUser();
+                String context = "/pages/" + page.getSitemapName() + "/" + page.getPathInSitemap();
+                
+                hasRight = _rightsManager.hasRight(login, right, context) == RightResult.RIGHT_OK;
+            }
+        }
+        
+        return hasRight;
+    }
+
+}
Index: main/plugin-web/src/org/ametys/web/repository/page/generators/PageTemplatesGenerator.java
===================================================================
--- main/plugin-web/src/org/ametys/web/repository/page/generators/PageTemplatesGenerator.java	(revision 0)
+++ main/plugin-web/src/org/ametys/web/repository/page/generators/PageTemplatesGenerator.java	(revision 0)
@@ -0,0 +1,77 @@
+/*
+ *  Copyright 2014 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.web.repository.page.generators;
+
+import java.io.IOException;
+import java.util.Map;
+import java.util.Set;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.ProcessingException;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.generation.ServiceableGenerator;
+import org.apache.cocoon.xml.AttributesImpl;
+import org.apache.cocoon.xml.XMLUtils;
+import org.xml.sax.SAXException;
+
+import org.ametys.plugins.repository.AmetysObjectResolver;
+import org.ametys.web.repository.page.Page;
+import org.ametys.web.skin.TemplatesAssignmentHandler;
+
+/**
+ * SAX the available templates of a given page
+ *
+ */
+public class PageTemplatesGenerator extends ServiceableGenerator
+{
+    /** The template assignment handler */
+    protected TemplatesAssignmentHandler _templatesAssignmentHandler;
+    /** The ametys object resolver */
+    protected AmetysObjectResolver _resolver;
+    
+    @Override
+    public void service(ServiceManager smanager) throws ServiceException
+    {
+        super.service(smanager);
+        _templatesAssignmentHandler = (TemplatesAssignmentHandler) smanager.lookup(TemplatesAssignmentHandler.ROLE);
+        _resolver = (AmetysObjectResolver) smanager.lookup(AmetysObjectResolver.ROLE);
+    }
+    
+    public void generate() throws IOException, SAXException, ProcessingException
+    {
+        Map<String, Object> jsParameters = (Map<String, Object>) objectModel.get(ObjectModelHelper.PARENT_CONTEXT);
+
+        String pageId = (String) jsParameters.get("pageId");
+        contentHandler.startDocument();
+        
+        XMLUtils.startElement(contentHandler, "templates");
+        
+        Page page = _resolver.resolveById(pageId);
+        Set<String> availablesTemplates = _templatesAssignmentHandler.getAvailablesTemplates(page);
+        
+        for (String name : availablesTemplates)
+        {
+            AttributesImpl attrs = new AttributesImpl();
+            attrs.addCDATAAttribute("id", name);
+            XMLUtils.createElement(contentHandler, "template", attrs);
+        }
+        
+        XMLUtils.endElement(contentHandler, "templates");
+        contentHandler.endDocument();
+    }
+
+}
